; WPQ[

(defun janken ()
    (let ((ch))
	(princ "WPQ[") (terpri)
	(loop
	    (princ "L[͂ĉ(g,c,p,q,h,h̓wvł):")
	    (setq ch (read))
	    (cond
		((or (eql ch 'g) (eql ch 'c) (eql ch 'p)) (fight ch))
		((eql ch 'h) (help))
		((eql ch 'q) (return t))))))

(defun help ()
    (princ "WPQ[ wv") (terpri)
    (princ "h : wv") (terpri)
    (princ "q : I") (terpri)
    (princ "g : O[") (terpri)
    (princ "c : `L") (terpri)
    (princ "p : p[") (terpri) (terpri)
)

(defun fight (you)
    (let ((computer) (you-win))
	(setq computer (go-computer))
	(show-info you computer)
	(setq you-win (did-you-win you computer))
	(show-result you-win)))

(defun go-computer ()
    (let ((n))
	(setq n (random 3))
	(cond
	    ((eql n 0) 'g)
	    ((eql n 1) 'c)
	    (t 'p))))

(defun show-info (you computer)
    (princ "Ȃ:") (janken-name you) (princ " ") (princ "Rs[^:") (janken-name computer) (terpri))

(defun janken-name (ch)
    (cond
	((eql ch 'g) (princ "O[I"))
	((eql ch 'c) (princ "`LI"))
	((eql ch 'p) (princ "p[I"))))

(defun did-you-win (you computer)
    (cond
	((eql you computer) 'e)
	((and (eql you 'g) (eql computer 'c)) 'w)
	((and (eql you 'g) (eql computer 'p)) 'l)
	((and (eql you 'c) (eql computer 'g)) 'l)
	((and (eql you 'c) (eql computer 'p)) 'w)
	((and (eql you 'p) (eql computer 'g)) 'w)
	((and (eql you 'p) (eql computer 'c)) 'l)))

(setq *you* 0)

(setq *computer* 0)

(defun show-result (ch)
    (let ()
	(cond
	    ((eql ch 'e) (princ "I") (terpri))
	    ((eql ch 'w) (setq *you* (1+ *you*)) (princ "Ȃ̏I") (terpri))
	    ((eql ch 'l) (setq *computer* (1+ *computer*)) (princ "Rs[^̏I") (terpri)))
	(show-win-rate) (terpri)))

(defun show-win-rate ()
    (let ((r))
	(princ "iȂ:") (prin1 *you*) (princ " ")
	(if (and (= *you* 0) (= *computer* 0)) (princ "0%j")
	    (progn (prin1 (setq r (floor (/ (* 100 *you*) (+ *you* *computer* 0.0))))) (princ "%j")))
	(terpri)
	(princ "iRs[^:") (prin1 *computer*) (princ " ")
	(if (and (= *you* 0) (= *computer* 0)) (princ "0%j")
	    (progn (prin1 (- 100 r)) (princ "%j")))
	(terpri)))

(janken)

